﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Event: ChangeValue (MinValue As Int, MaxValue as Int)

#DesignerProperty: Key: MinLimit, DisplayName: Min Range, FieldType: Int, DefaultValue: 0, Description: Minim value
#DesignerProperty: Key: MaxLimit, DisplayName: Max Range, FieldType: Int, DefaultValue: 24, Description: Maxim value
#DesignerProperty: Key: ColorBackground, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Color of background
#DesignerProperty: Key: ColorBase, DisplayName: Circle Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Color of background
#DesignerProperty: Key: ColorStick, DisplayName: Stick Color, FieldType: Color, DefaultValue: 0xFFDDDDDD, Description: Color of Stick
#DesignerProperty: Key: ColorBegin, DisplayName: Ball Min Color, FieldType: Color, DefaultValue: 0xFFFFD800, Description: Color of Level
#DesignerProperty: Key: ColorEnd, DisplayName: Ball Max Color, FieldType: Color, DefaultValue: 0xFFFFA54C, Description: Color of Level
#DesignerProperty: Key: ColorArc, DisplayName: Internal Arc Color, FieldType: Color, DefaultValue: 0xFFFFEFA8, Description: Internal color of the arc of the selected limits
#DesignerProperty: Key: ColorLevel, DisplayName: Level Color, FieldType: Color, DefaultValue: 0xFF4CAF50, Description: Color of Level
#DesignerProperty: Key: ColorText, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Color of Text

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Private Can As B4XCanvas
	Private PanelCircle As B4XView
	Private Diametro As Int
	Private LevelVis As Boolean = False
	
	Private Color_Background As Int = 0xFFFFFFFF
	Private Color_Base As Int = 0xFF000000
	Private Color_Begin As Int = 0xFF4CAF50
	Private Color_End As Int = 0xFF4CAF50
	Private Color_Level As Int = 0xFF4CAF50
	Private Color_Stick As Int = 0xFFAAAAAA
	Private Color_Text As Int = 0xFF000000
	Private Color_Arc As Int = 0xFFFFEFA8
	Private FontSize As Int = 14
	Private Min_Value As Int = 0
	Private Max_Value As Int = 24
	Private MinLimit As Int = 0
	Private MaxLimit As Int = 24
	Private Min_Level As Int = 0
	Private Max_Level As Int = 24
	Private StartDegree As Int = 270
	Private DeptPoint As Int = 30dip
	Private DeptStick As Int = 15dip
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	
	Color_Background = xui.PaintOrColorToColor(Props.Get("ColorBackground"))
	Color_Base = xui.PaintOrColorToColor(Props.Get("ColorBase"))
	Color_Begin = xui.PaintOrColorToColor(Props.Get("ColorBegin"))
	Color_End = xui.PaintOrColorToColor(Props.Get("ColorEnd"))
	Color_Stick = xui.PaintOrColorToColor(Props.Get("ColorStick"))
	Color_Level = xui.PaintOrColorToColor(Props.Get("ColorLevel"))
	Color_Text = xui.PaintOrColorToColor(Props.Get("ColorText"))
	If Props.ContainsKey("ColorArc") Then Color_Arc = xui.PaintOrColorToColor(Props.Get("ColorArc"))
	
	MinLimit=Props.Get("MinLimit")
	MaxLimit=Props.Get("MaxLimit")
	Min_Value=MinLimit
	Max_Value=MaxLimit/2
	
	mBase.Color=Color_Background
	PanelCircle=xui.CreatePanel("PanelCircle")
	'PanelCircle.SetLayoutAnimated(0,0,0,mBase.Width,mBase.Height)
	mBase.AddView(PanelCircle,0,0,mBase.Width,mBase.Height)
	Diametro=(Min(mBase.Width,mBase.Height)/2)-1dip
	Can.Initialize(PanelCircle)
	
	Draw
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	PanelCircle.Width=Width
	PanelCircle.Height=Height
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

Public Sub setColorBase(C As Int)
	Color_Base=C
	mBase.Color=Color_Base
End Sub

Public Sub setColorStick(C As Int)
	Color_Stick=C
	Draw
End Sub

Public Sub setColorLevel(C As Int)
	Color_Level=C
	Draw
End Sub

Public Sub setTextColor(C As Int)
	Color_Text=C
	Draw
End Sub

Public Sub setSizeFont(S As Int)
	FontSize=S
	Draw
End Sub

Public Sub getColorBase As Int
	Return Color_Base
End Sub

Public Sub getColorStick As Int
	Return Color_Stick
End Sub

Public Sub getColorLevel As Int
	Return Color_Level
End Sub

Public Sub getTextColor As Int
	Return Color_Text
End Sub

Public Sub getSizeFont As Int
	Return FontSize
End Sub

Public Sub getMinValue As Int
	Return Min_Value
End Sub

Public Sub getMaxValue As Int
	Return Max_Value
End Sub

Public Sub setMinValue(V As Int)
	Min_Value=Max(V,MinLimit)

	Draw
End Sub

Public Sub setMaxValue(V As Int)
	Max_Value=Min(V,MaxLimit)
	
	Draw
End Sub

Public Sub getMinRange As Int
	Return MinLimit
End Sub

Public Sub getMaxRange As Int
	Return MaxLimit
End Sub

Public Sub setMinRange(V As Int)
	MinLimit=v
	setMinValue(Min_Value)
	'Draw
End Sub

Public Sub setMaxRange(V As Int)
	MaxLimit=v
	setMinValue(Max_Value)
	'Draw
End Sub


Public Sub getMinLevel As Int
	Return Min_Level
End Sub

Public Sub getMaxLevel As Int
	Return Max_Level
End Sub

Public Sub setMinLevel(V As Int)
	Min_Level=v
	Draw
End Sub

Public Sub setMaxLevel(V As Int)
	Max_Level=v
	Draw
End Sub

Public Sub BringToFront
	mBase.BringToFront
End Sub

Public Sub setEnable(B As Boolean)
	mBase.Enabled=B
End Sub

Public Sub getEnable As Boolean
	Return mBase.Enabled
End Sub

Public Sub setHeight(B As Int)
	mBase.Height=B
End Sub
Public Sub setLeft(B As Int)
	mBase.Left=B
End Sub

Public Sub getLeft As Int
	Return mBase.Left
End Sub

Public Sub getHeight As Int
	Return mBase.Height
End Sub

Public Sub RemoveViewFromParent
	mBase.RemoveViewFromParent
End Sub

Public Sub RequestFocus
	mBase.RequestFocus
End Sub

Public Sub SendToBack
	mBase.SendToBack
End Sub

Public Sub Snapshot As B4XView
	Return mBase.Snapshot
End Sub

Public Sub setTop(B As Int)
	mBase.Top=B
End Sub

Public Sub getTop As Int
	Return mBase.Top
End Sub

Public Sub setVisible(B As Boolean)
	mBase.Visible=B
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub setWidth(B As Int)
	mBase.Width=B
End Sub

Public Sub getWidth As Int
	Return mBase.Width
End Sub

Public Sub getLevelVisible As Boolean
	Return LevelVis
End Sub

Public Sub setLevelVisible(B As Boolean)
	If LevelVis<>B Then
		LevelVis=b
		Draw
	End If
End Sub

' Degree=90 UP; 135 Left; 180 Down; 215 Right; 
' Degree=112 UP-Left;  202 Down-Left; 67 Up-Right; 237 Down-Rigt
Public Sub StartPoint(Degree As Int)
	StartDegree=Degree
	Draw
End Sub

Public Sub getBallSize As Int
	Return DeptPoint
End Sub

Public Sub setBallSize(Size As Int)
	DeptPoint=Size
	Draw
End Sub

Public Sub getStickSize As Int
	Return DeptStick
End Sub

Public Sub setStickSize(Size As Int)
	DeptStick=Min(Size,DeptPoint)
	Draw
End Sub

 '------------------------------- EVENT ---------------------------------
Private Sub PanelCircle_Touch (Action As Int, X As Float, Y As Float)
	' 0 down - 100 drag
	If Action=2 Then
		x=x-PanelCircle.Width/2
		y=y-PanelCircle.Height/2
		Dim Dg As Int = pymod(ATan2D(Y,X))
		Dim Vl As Int = MinLimit+pymod(Dg-StartDegree)*(MaxLimit-MinLimit)/360
		
		Dim DiffMin As Int = IIf(pymod(CalcDegree(Min_Value)-Dg)<180,pymod(CalcDegree(Min_Value)-Dg),pymod(360-CalcDegree(Min_Value)+Dg))
		Dim DiffMax As Int = IIf(pymod(CalcDegree(Max_Value)-Dg)<180,pymod(CalcDegree(Max_Value)-Dg),pymod(360-CalcDegree(Max_Value)+Dg))
		
		'Log(Vl & ") " & Dg & " : " &  CalcDegree(Min_Value) & " " & CalcDegree(Max_Value))
		If DiffMin>DiffMax Then 
			If Vl<>Min_Value Then
				Max_Value=Vl
				Draw
			End If
		Else
			If Vl<>Max_Value Then 
				Min_Value=Vl
				Draw
			End If
		End If
		If xui.SubExists(mCallBack,mEventName & "_ChangeValue",2) Then CallSub3(mCallBack,mEventName & "_ChangeValue",Min_Value,getMaxValue)
	End If
End Sub

Private Sub Draw
	Dim X, Y As Int 
	Dim Passo As Int = 5
	Dim BeginDegree  As Int = CalcDegree(Min_Value)
	Dim EndDegree  As Int = CalcDegree(Max_Value)
	Dim Num As Int = IIf(BeginDegree<=EndDegree,(EndDegree-BeginDegree)/Passo,(360+EndDegree-BeginDegree)/Passo)
	
	Can.DrawRect(Can.TargetRect,Color_Background,True,1dip)
	Can.DrawCircle(mBase.Width/2,mBase.Height/2,Diametro,Color_Base,True,1)

	' Stick and Arc
	Dim path As B4XPath
	For i=0 To Abs(Num)
		Dim dg As Float = pymod(BeginDegree+(i*Passo))
		
		X=(mBase.Width/2) + CosD(dg)*(Diametro-DeptPoint/2)
		Y=(mBase.height/2)+ SinD(dg)*(Diametro-DeptPoint/2)
		Can.DrawCircle(X,Y,DeptStick/2,Color_Stick,True,1dip)
		
		If i=0 Then path.Initialize(Can.TargetRect.CenterX,Can.TargetRect.CenterY)
		X=(mBase.Width/2) + CosD(dg)*(Diametro-(DeptPoint+DeptStick)/2)
		Y=(mBase.height/2)+ SinD(dg)*(Diametro-(DeptPoint+DeptStick)/2)
		path.LineTo(X,Y)
	Next
	path.LineTo(Can.TargetRect.CenterX,Can.TargetRect.CenterY)
	Can.DrawPath(path,Color_Arc,True,1dip)
	
	' BALL BEGIN
	X = CalcX(Min_Value)
	y = CalcY(Min_Value)
	Can.DrawCircle(X,Y,DeptPoint/2,Color_Begin,True,1dip)
	y = y+3dip
	Can.DrawText(Min_Value,X,Y,xui.CreateDefaultBoldFont(FontSize),Color_Text,"CENTER")
	
	' BALL END
	X = CalcX(Max_Value)
	y = CalcY(Max_Value)
	Can.DrawCircle(X,Y,DeptPoint/2,Color_End,True,1dip)
	y = y+3dip
	Can.DrawText(Max_Value,X,Y,xui.CreateDefaultBoldFont(FontSize),Color_Text,"CENTER")
	
	'draw level
	If LevelVis Then 
		Dim BeginDegree  As Int = CalcDegree(Min_Level)
		Dim EndDegree  As Int = CalcDegree(Max_Level)
		Dim Num As Int = IIf(BeginDegree<=EndDegree,(EndDegree-BeginDegree)/Passo,(360+EndDegree-BeginDegree)/Passo)
		
		Dim path As B4XPath
		path.Initialize(Can.TargetRect.CenterX,Can.TargetRect.CenterY)
		
		For i=0 To Abs(Num)
			Dim dg As Float = pymod(BeginDegree+(i*Passo))
			X=(mBase.Width/2) + CosD(dg)*(Diametro/2)
			Y=(mBase.height/2)+ SinD(dg)*(Diametro/2)
			path.LineTo(X,Y)
		Next
		path.LineTo(Can.TargetRect.CenterX,Can.TargetRect.CenterY)
		Can.DrawPath(path,Color_Level,True,1dip)
	End If
	
	Can.Invalidate
End Sub

Private Sub CalcX(Value As Int) As Int
	Return (mBase.Width/2) + CosD(StartDegree+360*((Value-MinLimit)/(MaxLimit-MinLimit)))*(Diametro-DeptPoint/2)
End Sub

Private Sub CalcY(Value As Int) As Int
	Return (mBase.height/2)+ SinD(StartDegree+360*((Value-MinLimit)/(MaxLimit-MinLimit)))*(Diametro-DeptPoint/2)
End Sub

Private Sub CalcDegree(Value As Int) As Int
	Return pymod(StartDegree+360*((Value-MinLimit)/(MaxLimit-MinLimit)))
End Sub

Private Sub pymod(V As Int) As Int
	Return (V+720) Mod 360
End Sub